#! /bin/sh
eval '(exit $?0)' && eval 'PERL_BADLANG=x;PATH="$PATH:.";export PERL_BADLANG\
;exec perl -x -S -- "$0" ${1+"$@"};#'if 0;eval 'setenv PERL_BADLANG x\
;setenv PATH "$PATH":.;exec perl -x -S -- "$0" $argv:q;#'.q
#!perl -w
+push@INC,'.';$0=~/(.*)/s;do(index($1,"/")<0?"./$1":$1);die$@if$@__END__+if 0
;#Don't touch/remove lines 1--7: http://www.inf.bme.hu/~pts/Magic.Perl.Header
#
# dff.pl -- fix .pfb font embedding problems of dvipdfm(1), dvips(1) and pdftex(1)
# by pts@fazekas.hu at Wed Mar 26 09:30:43 CET 2003
# -- Wed Mar 26 14:14:15 CET 2003
# renamed to dff.pl from dvipdfm_fontfix.pl at Wed Jul 23 10:21:12 CEST 2003
# dvips works at Wed Jul 23 13:30:57 CEST 2003
# pdftex works at Wed Jul 23 16:08:50 CEST 2003
# --dff-onepass=1 works at Mon Aug  4 00:31:37 CEST 2003
# --dff-map-dir works at Sun Nov  9 01:15:49 CET 2003
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#
# DFF (dff.pl) is a Perl script that is a transparent wrapper around
# dvipdfm(1), dvips(1) and pdftex(1), fixing many of their bugs concerning
# Type1 fonts, thus providing a consistent environment for creating PDFs with
# subsetted vector Type1 fonts using TeX.
# DFF should be used with teTeX.
#
# DFF provides the following extra features:
#
# -- automatically calls mktextfm(1) to create the missing TFM files (dvipdfm
#    cannot do this)
# -- clones the pdftex font .map files that usually contain references to
#    more Type1 fonts
# -- can clone and/or merge the pdftex, dvips and original dvipdfm font .map
#    files
# -- avoids font subsetting bugs in dvipdfm by filtering all Type1 fonts with
#    type1fix.pl (lfr.pfb, bchb8a.pfb etc.)
# -- removes the `-r' option from dvipdfm font .map files, so `fl' and other
#    ligatures will come out right (tested in Acrobat Reader 5.0 and gv)
# -- prints huge warnings about bitmap fonts inserted into the final PDF
# -- the directory dff.fnt (with fonts created by type1fix.pl) can be copied
#    from another machine -- type1fix.pl isn't needed on localhost
# -- dvipdfm subsetting is turned off when type1fix.pl not found to aboid bugs
# -- dvipdfm goes on embedding a .pfb font even if it is missing from the
#    .map file! This cannot be overcome :-(. So specifying `-dff-pdftex-maps=0
#    dvipdfm') will embed the font cmbx10 properly.
#
# External utilities used: kpsewhich dvipdfm mktextfm type1fix.pl
#
# Since many fonts are missing from dvipdfm's .map files, the pdfTeX .map
# files are used instead by default (--dff-dvips-maps=0 --dff-pdftex-maps=1
# --dff-dvipdfm-maps=0)
#
# A very typical TeX file that is corrected by DFF:
#
#  % bp unknown: \special{papersize=300 bp,200pt}
#  \special{pdf: pagesize width 300pt height 200pt}
#  \font\fOTi=hlxr7t
#  \font\fTi= hlxr8t
#  \font\gOTi=bchb7t
#  \font\gTi= bchb8t
#  % Dat: The  and  hungarian accented chars are not right
#  {\fOTi Hello, World! rvztr tkrfrgp ffl.\char15\char16}
#  {\fTi  Hello, World! rvztr tkrfrgp ffl.\char15\char16}
#  {\gOTi Hello, World! rvztr tkrfrgp ffl.\char15\char16}
#  {\gTi  Hello, World! rvztr tkrfrgp ffl.\char15\char16}
#  \end
#
# !! problem on russell after 1st generation of lmtt10.pfb:
# Warning: pdflatex (file lmtt10.pfb): cannot open Type 1 font file for reading
#
# dff.pl can be used to generate .map files (in dvips(1) format). For example,
# the command
#
#   dff.pl -dff-map-dir=mydir -dff-map-nc=ps2pk.map -dff-pdftex-maps=0 ps2pk
#
# generates dff_psk.map with entries in standard ps2pk.map overridden by
# map files in directory `mydir' (recursively). If dff_psk.map is renamed to
# ps2pk.map, then xdvi(1) in teTeX of Debian Woody would become quickly aware
# of the Type1 fonts in .map files in `mydir' (see also the
# `dvipsmap ps2pk.map' directive xdvi.cfg).
#
# Imp: dvips -Ppdf with different line drawing routine
# Imp: running pdftex and dvipdfm only once, after caching the query results
# Imp: running pdftex enough times
# Imp: verify type1fix.pl with PFA
# Imp: test it with a PFA file
# !! warning for missing PostScript fonts perl -n -0777 -e'while(/^%%BeginFont: +(\S+)\s+%%EndFont/gm){ print "$1\n" }' n.ps
# Dat: pdfTeX creates .pdf 5090 bytes, but after type1fix cmr10.pfb, 5188 bytes
# Dat: dvipdfm SUXX: embeds PFB files missing from the map file
# Dat: dvipdfm SUXX: All instances of the same Type1 font must have the same encoding. (pts: I'm not sure about this)
# Dat: dvipdfm SUXX: serious bugs embedding VF T1 fonts: hlxr8t and \font\fTi=bchb8t, see accentyed glyphs (bchb8a.pfb) (`dvipdfm -e' works well) (type1fix.pl fixes the problem)
# Dat: rm /var/spool/texmf/tfm/jknappen/ec/ecss1440.tfm
# OK : "ecss1440:\nUnable to find a TFM or OFM file" -> mktextfm
# OK : avoid dvips auto-rotating (--dff-force-paper=1)
# OK : avoid dvips: no match for special paper size found; using default
# Dat: fixing "\papersize=WD bp,HT bp" -> (doesn't know of bp as a
#      measurement unit; in, cm, pt is SURE) "\special{pdf: pagesize width
#      300pt height 200pt} needs modification of the DVI file not only letter,
#      legal, ledger, tabloid, a4, a3
#
use integer;
use strict;

#** @return $_[0] quoted for /bin/sh
sub shq($) {
  my $S=$_[0];
  return $S if $S!~y@A-Za-z0-9_,:./-@@c and length($S)>0;
  $S=~s@'@'\\''@g;
  return "'$S'"
}

sub error($) {
  print STDERR "DFF fatal error: $_[0]\n";
  exit 2;
}
sub info($) {
  print STDERR "DFF info: $_[0]\n";
}
sub warning($) {
  print STDERR "DFF warning: $_[0]\n";
}
#** @param $_[0] filename, modified in place
#** @param $_[1] extension, e.g ".dvi"
sub addext($$) {
  $_[0].=$_[1] if $_[0]!~m@[.][^/\\.]+\Z(?!\n)@;
}
#** @param $_[0] filename, modified in place
#** @param $_[1] extension, e.g ".dvi"
sub setext($$) {
  $_[0]=~s@[.][^/\\.]+\Z(?!\n)@@;
  $_[0].=$_[1];
}

#** @param $_[0] "config.ps", "config" or "pdftex.cfg"
#** @param $_[1] argument of --progname
#** @param $_[2] kpse --format= value
#** @return the absoulte version of $_[0], or undef
sub getconf_absname_try($$;$) {
  my $confrel=$_[0];
  my $format=$_[2];
  $format='other text files' if !defined $format;
  # vvv $confrel and $_[1] are assumed not to contain weird characters
  my $cmd="kpsewhich --progname=$_[1] --format=\"$format\" -- \"$confrel\" 2>&1";
  my $confabs=qx($cmd);
  chomp $confabs;
  return undef if
       length($confabs)<length($confrel)-1
    or substr($confabs,-length($confrel)-1,1) ne "/"
    or substr($confabs,-length($confrel)) ne $confrel
    or !-f $confabs;
  $confabs
}

#** @param $_[0] "config.ps", "config" or "pdftex.cfg"
#** @param $_[1] argument of --progname
#** @param $_[2] kpse --format= value
#** @return the absoulte version of $_[0]
sub getconf_absname($$;$) {
  my $confabs=&getconf_absname_try(@_);
  error "config file not found: $_[0]\n  Are you sure that `$_[1]' is installed?" if
    !defined $confabs;
  $confabs
}

#** @param $_[0] font filename
#** @return the absoulte version of $_[0]
sub getfont_absname($) {
  my $confrel=$_[0];
  my $cmd="kpsewhich --format=\"type1 fonts\" -must-exist -- \"$confrel\" 2>&1";
  my $confabs=qx($cmd);
  chomp $confabs;
  return undef
    if length($confabs)<length($confrel)-1
    or substr($confabs,-length($confrel)-1,1) ne "/"
    or substr($confabs,-length($confrel)) ne $confrel
    or !-f $confabs;
  $confabs
}

my %encname_cache;
#** @param $_[0] an .enc filename, e.g "8r.enc"
#** @return the PostScript encoding name inside it, e.g "TeXBase1Encoding",
#**   or undef
sub getenc_encname($) {
  my $encrel=$_[0];
  return $encname_cache{$encrel} if exists $encname_cache{$encrel};
  my $encname=undef;
  my $cmd="kpsewhich --format=\"PostScript header\" -- \"$encrel\" 2>&1";
  my $encabs=qx($cmd);
  if ($encabs eq "") { # needed to find ot1r.enc and ot1alt.enc
    $cmd="kpsewhich --progname=dvipdfm --format=\"other text files\" -- \"$encrel\" 2>&1";
    $encabs=qx($cmd);
  }
  chomp $encabs;
  if (length($encabs)<length($encrel)-1
   or substr($encabs,-length($encrel)-1,1) ne "/"
   or substr($encabs,-length($encrel)) ne $encrel
   or !open ENC, "< $encabs") {
  } else {
    while (<ENC>) {
      s@%.*@@; # remove comments
      if (m@^\s*/([^\s\[{(]+)@) { $encname=$1; last } #)
      # Imp: also verify the `[' token coming after the encoding name
    }
    close ENC;
  }
  warning "missing or bad encoding file: $encrel" if !defined $encname;
  $encname_cache{$encrel}=$encname
}

# --- cmdline options interpreter

my %opt_keys=  qw(do 1 map 1 map-nc 1 map-dir 1 map-dir-if 1             driver 1 base14-upload 1 basefonts 1     type1fix 1 to-curdir 1 path-maps 1 dvips-maps 1 pdftex-maps 1 dvipdfm-maps 1 force-paper 1 onepass 1 maps-only 1 safer 1 find-fonts 1 subset unchaged);
my @opt_append=qw(do 1                          map-dir-if ./dff_map.dir          base14-upload 0 basefonts guess type1fix 1 to-curdir 1 path-maps 1 dvips-maps 0 pdftex-maps 1 dvipdfm-maps 0 force-paper 1 onepass 1 maps-only 0 safer 0 find-fonts 1);
#** @param $_[0] "--dff-dvips-maps"
#** @return ("dvips-maps", 1) or ("", "") on error
sub opt_val($) {
  my($k,$v)=("","");
  my $opt=$_[0];
  if ($opt=~m@\A-+dff[-_]([\w-]+)(=.*)?@si) {
    $k=lc($1); $k=~y@_@-@;
    if (exists $opt_keys{$k}) { 
      $v=defined($2) && length($2) ? substr($2,1) : $opt_keys{$k};
    } else { $k="" }
  }
  ($k,$v)
}

sub opt_val_istrue($) {
  my $v=$_[0];
  return 1 if $v eq "1" or $v eq "yes" or $v eq "true" or $v eq "";
  return 0 if $v eq "" or $v eq "no" or $v eq "0" or $v eq "false";
  error "invalid boolean option: $v";
}
sub BF_GUESS(){4}
sub BF_NONE(){5}
sub opt_val_basefonts($) {
  my $v=lc($_[0]);
  $v= ($v eq 'guess' ) ? 4 # : ($v eq 'adobe-bi') ? 0
    : ($v eq 'adobe-kb') ? 1 : ($v eq 'urw-kb') ? 2 : ($v eq 'urw-urw' ) ? 3 : -1;
  return $v if $v>0;
  error "invalid basefonts option: $_[0]";
}
#** @param $_[0] "--dff-$k=$v", ($k,$v) is returned by opt_val()
sub opt_istrue($) {
  my($kk,$v)=split/=/,$_[0];
  opt_val_istrue $v
}

sub DR_DVIPDFM(){1}
sub DR_DVIPS(){2}
sub DR_PDFTEX(){3}
sub DR_PS2PK(){4}
sub DR_XDVI(){5}
sub DR_XDVICFG(){6}
my $opt_driver;
my $opt_dr; # DR_*

my @opts; # a list of command-line options addressed to us
#** Appends to @opts
#** @param arrayref, e.g \@ARGV;
sub opt_strip($) {
  my($k,$v);
  my $argv=$_[0];
  my $I;
  my %h=%opt_keys;
  for ($I=0;$I<@$argv;$I++) {
    ($k,$v)=opt_val($argv->[$I]);
    last if! length($k);
    delete $h{$k};
    push @opts, "--dff-$k=$v";
  }
  if (@$argv) {
    $opt_driver=$argv->[$I++];
    my %driver_map=(
      'dvipdfm' => DR_DVIPDFM,
      'ps2pk' => DR_PS2PK,
      'xdvi' => DR_XDVI, # Dat: changed  from DR_PS2PK
      'xdvigz' => DR_XDVI,
      'xdvicfg' => DR_XDVICFG, # Dat: changed  from DR_XDVI
      'dvips' => DR_DVIPS,
      'pdftex' => DR_PDFTEX,
      'pdflatex' => DR_PDFTEX,
      # Imp: pdf* to DR_PDFTEX
    );
    $opt_dr=defined($opt_driver) ? $driver_map{$opt_driver} : undef;
    error "driver must be one of: @{[sort keys%driver_map]}" if
      !defined $opt_dr;
  }
  splice @$argv, 0, $I;
  # vvv push default values to the end, for each option having a default value,
  #     but not specified yet
  for ($I=0;$I<@opt_append;$I+=2) {
    push @opts, "--dff-$opt_append[$I]=$opt_append[$I+1]" if exists $h{$opt_append[$I]};
  }
}

# --- main()

# delete $ENV{T1FONTS}; # used by kpsewhich

print STDERR "This is DFF (dff.pl 0.23), that runs dvips, dvipdfm or pdftex
GNU GPL >=2.0. Written and (C) Late Feburary 2004 by pts\@fazekas.hu.\n\n";

sub usage() {
  print STDERR "Usage: $0 [dff-options]    dvipdfm [ dvipdfm-options] <input.dvi>
       $0 [dff-options]      dvips [   dvips-options] <input.dvi>
       $0 [dff-options] pdf[la]tex [pdflatex-options] <input.tex>
       $0 [dff-options]   xdvi{|gz|cfg} [xdvi-options] <input.dvi>
       $0 [dff-options] ps2pk  # create dff_psk.map

The dff-options are:
--dff-do[=1]                ignored
--dff-force-paper[=1]       force paper size for dvips(1)
--dff-onepass[=1]           run dvips/dvipdfm/pdftex only once, if applicable
[--dff-basefonts=guess]     upload base 35 fonts: adobe-kb urw-kb urw-urw
[--dff-map=FONT.MAP ...]    load this Type1 font map file
[--dff-map-nc=FONT.MAP ...] load this Type1 font map file, but not from curdir
[--dff-map-dir=DIR ...]     load all .map files in this dir (recursively)
[--dff-map-dir-if=FILE ...] load all .map files from dir of FILE if FILE
[--dff-base14-upload=0]     upload base 14 fonts to printer (!adobe-bi)
[--dff-maps-only=0]         generate only dff_*.map, don't run driver
--dff-type1fix[=1]          use type1fix.pl to fix all Type1 fonts
--dff-to-curdir[=1]         put target PDF to curdir (not DVI dir)
[--dff-path-maps=1]         use font maps found in \$DFF_MAP_PATH
[--dff-dvips-maps=0]        use font maps found in dvips config.ps
--dff-pdftex-maps[=1]       use font maps found in pdftex pdftex.cfg
[--dff-dvipdfm-maps=0]      use font maps found in dvipdfm config
[--dff-find-fonts=1]        find fonts other than in dff.fnt/
[--dff-driver=DRIVER]       driver is dvips or `strace dvips' etc.
[--dff-subset=MODE]         MODE: subset, whole, none, [unchanged]

Run `dvipdfm' ot `dvips --help' or `man pdftex' to get help.\n";
  #{ exec "dvipdfm" }
  #error "command not found: dvipfm";
  exit 2
}

usage if !@ARGV or $ARGV[0]eq'-h'  or $ARGV[0]eq'--help';
opt_strip \@ARGV;
## die "(@opts)";
usage if @ARGV and $ARGV[0]=~m@\A-+dff@;
my $opt_onepass=grep { /\A--dff-onepass=(.*)/s and opt_val_istrue($1) } @opts;

my $opt_subset='unchanged';
for my $opt (@opts) { $opt_subset=$1 if $opt=~/\A--dff-subset=(.*)/s }
my %OPT_SUBSET_VALS=qw(unchanged 1  subset 1  whole 1  none 1);
error "unknown value for --dff-subset: $opt_subset" if !exists
  $OPT_SUBSET_VALS{$opt_subset};
if ($opt_subset eq 'unchanged') {}
elsif (($opt_dr!=DR_DVIPS and $opt_dr!=DR_PDFTEX)) {
  error "invalid value for --dff-subset with driver $opt_driver: $opt_subset";
}
# Dat: `dff.pl dff-subset=subset pdflatex' prepends to FontName, e.g.
#      /YYZRED+FontName. =whole and =none don't do this

my $dviname=$ARGV[-1]; # must be the last one for dvipdfm(1) (and also for dvips and pdf[la]tex)
error "must specify source file name" if
  !defined $dviname and
  $opt_dr!=DR_PS2PK and $opt_dr!=DR_XDVICFG and
  grep { /\A--dff-maps-only=(.*)/s and !opt_val_istrue($1) } @opts;
if ($opt_dr==DR_PS2PK or $opt_dr==DR_XDVICFG or !defined $dviname) {
  undef $dviname;
} elsif ($opt_dr==DR_XDVI) {
  addext $dviname,".dvi";
  error "DVI file not found: $dviname" if !-f $dviname;
} elsif ($opt_dr==DR_DVIPDFM or $opt_dr==DR_DVIPS) {
  addext $dviname,".dvi";
  error "DVI file not found: $dviname" if !-f $dviname;
  if (grep { /\A--dff-to-curdir=(.*)/s and !opt_val_istrue($1) } @opts) {
    my $opdfname=$dviname;
    if ($opt_dr==DR_DVIPS) {
      setext $opdfname,".ps";
    } elsif ($opt_dr==DR_DVIPDFM) {
      setext $opdfname,".pdf";
      unshift @ARGV, '-o', $opdfname
      # ^^^ Inserts as first option. Will be overridden by user's explicit `-o'.
    }
  }
} elsif ($opt_dr==DR_PDFTEX) {
  my $texname=$ARGV[-1];
  addext $texname, '.tex';
  error "TeX source file not found: $texname" if !-f $texname;
  if (grep { /\A--dff-to-curdir=(.*)/s and !opt_val_istrue($1) } @opts) {
    error "$opt_driver always puts output to curdir"
  }
} else { die }

# --- Query the TeX fontnames used

#** @param $_[0] DVI file name
#** @return arrayref of fontnames (e.g ['cmr10','ectt1440'])
sub dvi_fonts($) {
  my $dviname=$_[0];
  my %H;
  my $S;
  if (0) {
    my $dvitype_cmd="dvitype -output-level=0 ".shq($dviname)." 2>&1";
    info "Running $dvitype_cmd";
    error "dvitype open failed" unless open PIPE, "$dvitype_cmd|";
    while (defined($S=<PIPE>)) {
      if ($S=~/^Font\s+\d+:\s*(\S+)(---|\s*\Z)/) { $H{$1}=1 } # more than once
    }
    error "dvitype failed" if !close PIPE;
  } else { # parse the DVI directly
    error "cannot open DVI: $!" if !open D, "< $dviname";
    error "cannot seek in DVI: $!" if !seek D, -32, 2; # Dat: >=32 bytes
    die unless 32==read D, $S, 32;
    $S=~s@\xDF+\Z(?!\n)@@; # remove TRAILERs
    error "missing POSTPOST" if $S!~/\xF9(....).\Z(?!\n)/s;
    my $POST_ofs=unpack"N",$1;
    error "cannot seek to POST ($POST_ofs): $!" if !seek D, $POST_ofs, 0;
    die unless 29==read D, $S, 29;
    error "missing POST" if substr($S,0,1)ne"\xF8";
    my $C;
    while (defined($C=getc D)) {
      if ($C eq"\xF3") { # FNT_DEF1
        die unless 13==read D, $S, 13;
      } elsif ($C eq"\xF4") { # FNT_DEF2
        die unless 14==read D, $S, 14;
      } elsif ($C eq"\xF9") { last } # POST
      die unless 2==read D, $S, 2;
      my $fontlen=unpack "n", $S;
      die unless $fontlen==read D, $S, $fontlen;
      $H{$S}=1; # mark font as used
    }
    die if !defined $C;
    close D;
  }
  my $ret=[sort keys%H];
  info "Fonts used: @$ret";
  $ret
}

# --- Run mktextfm(1) to generate fonts

my %all_fonts;
if (!defined $dviname) {
} elsif ($opt_dr==DR_DVIPDFM or $opt_dr==DR_DVIPS or $opt_dr==DR_XDVI) {
  my %fonts=map{$_=>1}@{dvi_fonts$dviname}; # "ecrm1000" => 1
  %all_fonts=%fonts; # combining this with the previous line would give warning in Perl v5.6.1
  my $iter=0;
  while (keys %fonts) { # Remove existing TFM fonts from %fonts
    # vvv Dat: the Linux kernel allows <32768 arguments to a process. I hope
    # that no DVI file uses as many fonts.
    my $me=$iter==0 ? "": " --must-exist";
    my $kpsewhich_cmd="kpsewhich$me --format=tfm --  ".join('  ', map {shq"$_.tfm"} keys %fonts);
    # ^^^ Dat: --must-exist forces a disk search beyond ls-lR; we don't need it
    # ^^^ Dat: teTeX finds /var/cache/fonts/tfm/jknappen/ec/ecbx2074.tfm only with --must-exist
    info "Running $kpsewhich_cmd";
    error "kpsewhich open failed" unless open PIPE, "$kpsewhich_cmd|";
    while (<PIPE>) {
      chomp;
      if (m@([^/\\]+)\.tfm@i and -f $_) {
        ## print "found font $1 .tfm\n";
        if (!exists $fonts{$1}) {
          warning "unexpected font: $1";
        } else { delete $fonts{$1} }
      }
    }
    close PIPE; # may fail if some files are not found
    last if !keys %fonts;
    error "failed to generate fonts: @{[sort keys %fonts]}" if $iter++>1;
    next if $iter==1;
    for my $font (sort keys %fonts) {
      ## print "missing font: $font.\n";
      info "Running mktextfm ".shq($font);
      # error "mktextfm failed" if! # Dat: may fail
      system "mktextfm", $font;
    }
  }
  # my $got=qx($dvitype_cmd);
} elsif ($opt_dr==DR_PDFTEX) {
  # nothing to do
} else { die }

# --- Collect font .map files used by pdftex(1) and/or dvips(1)

my @dp_maps; # relative .map filenames used by pdftex(1), dvips(1), dvipdfm(1)
my @dp_cmds;

#** The names of .map files the user usually doesn't want to add by
#** --dff-map-dir=, because they are generated from real .map files.
my %po_maps=qw{psfonts.map 1 ps2pk.map 1 pdftex.map 1 myfonts.map 1
  dff_ps.map 1 dff_m.map 1 dff_t.map 1 dff_psk.map 1};

#** @param $_[0] listref of dirnames
sub add_map_dirs($) {
  my $dirs=$_[0];
  for my $dir (@$dirs) {
    if (opendir D, $dir) {
      my $entry;
      while (defined($entry=readdir D)) {
        next if $entry eq '.' or $entry eq '..';
        if (!-l "$dir/$entry" and -f _ and $entry=~/[.]map\Z(?!\n)/) {
	  if (exists $po_maps{$entry}) {
	    warning "possibly unwanted map, not added: $dir/$entry"
		# Imp: emit this warning later
	  } else {
	    push @dp_maps, "$dir/$entry";
	    push @dp_cmds, "true";
	  }
        } elsif (-d _) {
          # Imp: do a depth-first search instead of a breadth-first search
          push @$dirs, "$dir/$entry";
        }
      }
      closedir D;
    } else { warning "cannot list dir: $dir" }
  }
}

for my $opt (@opts) {
  # ^^^ we need this iteration so we can distinguish between the order of the
  #     options. The --dff-*-maps specified first has precedence
  if ($opt=~/\A--dff-map=(.*)/s) {
    push @dp_maps, $1;
    push @dp_cmds, "kpsewhich --progname= --format=\"other text files\" -- ".shq($1);
  } elsif ($opt=~/\A--dff-map-nc=(.*)/s) {
    push @dp_maps, $1;
    push @dp_cmds, "cd /; kpsewhich --progname= --format=\"other text files\" -- ".shq($1);
  } elsif ($opt=~/\A--dff-map-dir=(.*)/s) {
    add_map_dirs([$1]);
  } elsif ($opt=~/\A--dff-map-dir-if=(.+)\/([^\/]+)/s) {
    add_map_dirs([$1]) if -f "$1/$2";
  } elsif ($opt=~/\A--dff-path-maps=(.*)/s and opt_val_istrue($1)) {
    add_map_dirs [grep{length}split/:+/,$ENV{DFF_MAP_PATH}] if
      exists $ENV{DFF_MAP_PATH};
  } elsif ($opt=~/\A--dff-dvips-maps=(.*)/s and opt_val_istrue($1)) {
    my $confabs=getconf_absname("config.ps","dvips");
    my @maps;
    info "Reading $confabs";
    die unless open F, "< $confabs";
    while (<F>) {
      if (/^\s*p\s+[+]\s*(\S+)/i) {
        print "map + $1\n";
        push @maps, $1;
      } elsif (/^\s*p\s+(\S+)/i) {
        print "map $1\n";
        @maps=$1;
      }
    }
    die unless close F;
    push @dp_maps, @maps;
    push @dp_cmds, map { "kpsewhich --progname= --format=\"other text files\" -- ".shq($_) } @maps;
    info "Map files now: @dp_maps";
  } elsif ($opt=~/\A--dff-pdftex-maps=(.*)/s and opt_val_istrue($1)) {
    my $confabs=getconf_absname_try("pdftex.cfg","pdftex"); # tetex 2.0
    my @maps;
    if (!defined $confabs) {
      $confabs=getconf_absname_try("pdftexconfig.tex","pdftex","tex"); # tetex 3.0
      error "pdftex config files not found\n" if !defined $confabs;
      # vvv Dat: pdftexconfig.tex in tetex 3.0 (but no map entries!!)
      # Dat: make it work in tetex 3.0, see default \pdfmapfile{+pdftex.map}
      #      in pdftexconfig.tex parsed at format generation time
      info "Reading $confabs";
      die unless open F, "< $confabs";
      @maps=('pdftex.map'); # Dat: by default
      while (<F>) {
        # vvv Imp: `-' instead of `+'
        if (/^\s*\\pdfmapfile\s*\{([+=]?)([^\}\n\r]+)/i) {
          @maps=() if 0==length($1);
          push @maps, $2;
        }
      }
      die unless close F;
    } else {
      info "Reading $confabs";
      die unless open F, "< $confabs";
      while (<F>) {
        if (/^\s*map\s+[+]\s*(\S+)/i) {
          ## print "map $1\n";
          push @maps, $1;
        } elsif (/^\s*map\s+(\S+)/i) {
          ## print "map $1\n";
          @maps=$1;
        }
      }
      die unless close F;
    }
    push @dp_maps, @maps;
    # vvv Dat: pdftex.map is located in the dvips directory, so progname=dvips
    # vvv Dat: `-progname=' will find dvipdfm(1) maps instead -- not dvips .map's
    push @dp_cmds, map { "kpsewhich --progname=dvips --format=\"other text files\" -- ".shq($_) } @maps;
    info "Map files now: @dp_maps";
  } elsif ($opt=~/\A--dff-dvipdfm-maps=(.*)/s and opt_val_istrue($1)) { my
    $confabs=getconf_absname("config","dvipdfm"); info "Reading $confabs";
    die unless open F, "< $confabs"; while (<F>) {
      if (/^\s*f\s+(\S+)/i) {
        push @dp_maps, $1;
        # Dat: also works with "--progname="
        push @dp_cmds, "kpsewhich --progname=dvipdfm --format=\"other text files\" -- ".shq($1);
      }
    }
    die unless close F;
    info "Map files now: @dp_maps";
  }
}

# --- Select fontnames for the base 35 fonts
# Dat: it is impossible to know now whether these fonts are really used in
#      the DVI

my %pf_subst; # { "wrong.pfb" => "right.pfb" ... }
{ my $basefonts=[map { /\A--dff-basefonts=(.*)/s ? opt_val_basefonts($1) : () }@opts]->[-1];
  $basefonts=BF_GUESS if $basefonts==BF_NONE and $opt_dr==DR_PDFTEX;
  my $base14_upload=! !grep { /\A--dff-base14-upload=(.*)/s and opt_val_istrue($1) } @opts;
  my $base14_noupload0=!$base14_upload;
  $base14_upload=1 if $opt_dr==DR_PDFTEX or $opt_dr==DR_XDVI or
    $opt_dr==DR_PS2PK or $opt_dr==DR_XDVICFG;
  # ^^^ some of the base fonts will be slanted or extended -- pdfTeX must upload these
  if ($basefonts==BF_GUESS) {
    $basefonts= defined getfont_absname("ptmr8a.pfb") ? 1 # Times-Roman
              : defined getfont_absname("utmr8a.pfb") ? 2
              : defined getfont_absname("n021003l.pfb") ? 3 : BF_NONE;
  }
  $base14_upload=0 if $basefonts==BF_NONE;
  my @fontsets=qw(adobe-bi adobe-kb urw-kb urw-urw guess none);
  my $bs=$base14_upload ? "" : " adobe-bi";
  info "Using base 35 fonts: $fontsets[$basefonts]$bs";

# urw-kb:   these are included in teTeX's texmf tree
#           URW fonts (download type1 files using Berry names)
# urw-urw:  these are included in ghostscript 4.0 and later. Adjust the
#           search paths for type1 and afm files in texmf.cnf if you set this
#           URW fonts (download type1 files using URW names)
# adobe-kb: use this if you have the original Adobe fonts. Install the                            
#           type1 and afm files with Berry names.
#           Adobe fonts (download type1 files using Berry names)
# adobe-bi: Adobe fonts built-in to the printer
# 
# The standard 14 fonts:
# 
# FontName            adobe-kb     urw-kb        urw-urw
# ~~~~~~~~            ~~~~~~~~     ~~~~~~        ~~~~~~~
  my @base14a=qw~
Courier-Bold          pcrb8a.pfb   ucrb8a.pfb    n022004l.pfb
Courier-BoldOblique   pcrbo8a.pfb  ucrbo8a.pfb   n022024l.pfb
Courier               pcrr8a.pfb   ucrr8a.pfb    n022003l.pfb
Courier-Oblique       pcrro8a.pfb  ucrro8a.pfb   n022023l.pfb
Helvetica-Bold        phvb8a.pfb   uhvb8a.pfb    n019004l.pfb
Helvetica-BoldOblique phvbo8a.pfb  uhvbo8a.pfb   n019024l.pfb
Helvetica             phvr8a.pfb   uhvr8a.pfb    n019003l.pfb
Helvetica-Oblique     phvro8a.pfb  uhvro8a.pfb   n019023l.pfb
Symbol                psyr.pfb     usyr.pfb      s050000l.pfb
Times-Bold            ptmb8a.pfb   utmb8a.pfb    n021004l.pfb
Times-BoldItalic      ptmbi8a.pfb  utmbi8a.pfb   n021024l.pfb
Times-Roman           ptmr8a.pfb   utmr8a.pfb    n021003l.pfb
Times-Italic          ptmri8a.pfb  utmri8a.pfb   n021023l.pfb
ZapfDingbats          pzdr.pfb     uzdr.pfb      d050000l.pfb
~;
# TeX font names for which pdfTeX doesn't support adobe-bi (because of
# ExtendFont and SlantFont): pcrr8rn psyro ptmbo8r ptmr8rn ptmro8r ptmrr8re
# (pbkdo8r pbklo8r pncbo8r pncro8r pplbo8r pplr8rn pplro8r pplrr8re pplru8r)
# 
# The extra LaserWriter 35 fonts (extra over the standard 14 fonts):
#
# FontName                    adobe-kb      urw-kb        urw-urw
# ~~~~~~~~                    ~~~~~~~~      ~~~~~~        ~~~~~~~
  my @base35a=qw~
AvantGarde-Demi               pagd8a.pfb    uagd8a.pfb    a010015l.pfb
AvantGarde-DemiOblique        pagdo8a.pfb   uagdo8a.pfb   a010035l.pfb
AvantGarde-Book               pagk8a.pfb    uagk8a.pfb    a010013l.pfb
AvantGarde-BookOblique        pagko8a.pfb   uagko8a.pfb   a010033l.pfb
Bookman-Demi                  pbkd8a.pfb    ubkd8a.pfb    b018015l.pfb
Bookman-DemiItalic            pbkdi8a.pfb   ubkdi8a.pfb   b018035l.pfb
Bookman-Light                 pbkl8a.pfb    ubkl8a.pfb    b018012l.pfb
Bookman-LightItalic           pbkli8a.pfb   ubkli8a.pfb   b018032l.pfb
Helvetica-Narrow-Bold         phvb8an.pfb   uhvb8an.pfb   n019044l.pfb
Helvetica-Narrow-BoldOblique  phvbo8an.pfb  uhvbo8an.pfb  n019064l.pfb
Helvetica-Narrow              phvr8an.pfb   uhvr8an.pfb   n019043l.pfb
Helvetica-Narrow-Oblique      phvro8an.pfb  uhvro8an.pfb  n019063l.pfb
NewCenturySchlbk-Bold         pncb8a.pfb    uncb8a.pfb    c059016l.pfb
NewCenturySchlbk-BoldItalic   pncbi8a.pfb   uncbi8a.pfb   c059036l.pfb
NewCenturySchlbk-Roman        pncr8a.pfb    uncr8a.pfb    c059013l.pfb
NewCenturySchlbk-Italic       pncri8a.pfb   uncri8a.pfb   c059033l.pfb
Palatino-Bold                 pplb8a.pfb    uplb8a.pfb    p052004l.pfb
Palatino-BoldItalic           pplbi8a.pfb   uplbi8a.pfb   p052024l.pfb
Palatino-Roman                pplr8a.pfb    uplr8a.pfb    p052003l.pfb
Palatino-Italic               pplri8a.pfb   uplri8a.pfb   p052023l.pfb
ZapfChancery-MediumItalic     pzcmi8a.pfb   uzcmi8a.pfb   z003034l.pfb
  ~;
  my $I;
  my $B=$base14_upload ? $basefonts : 0;
  die if $B>3;
  for ($I=0;$I<@base14a;$I+=4) {
    # Dat: dvipdfm accepts .map line `ptmr8r 8r Times-Roman', with a PS /FontName
    #      instead of a .pfb filename
    $pf_subst{$base14a[$I+$B]}=$base14a[$I+$B] if $opt_dr==DR_PDFTEX and $base14_noupload0;
    $pf_subst{$base14a[$I+(($B+1)&3)]}=
    $pf_subst{$base14a[$I+(($B+2)&3)]}=
    $pf_subst{$base14a[$I+(($B+3)&3)]}=$base14a[$I+$B];
  }
  if ($basefonts!=BF_NONE) {
    die if ($B=$basefonts)>3;
    for ($I=0;$I<@base35a;$I+=4) {
      # $pf_subst{$base35a[$I+$B]}=$base35a[$I+$B] if $opt_dr==DR_PDFTEX;
      $pf_subst{$base35a[$I+(($B+1)&3)]}=
      $pf_subst{$base35a[$I+(($B+2)&3)]}=
      $pf_subst{$base35a[$I+(($B+3)&3)]}=$base35a[$I+$B];
    }
  }
  ## die join"\n",%pf_subst;
}

# --- Process the map files, create dff_*.map

my @config_fnc; # ('dff_ps.map','config.dfp');
if ($opt_dr==DR_DVIPDFM)  {
  push @config_fnc, 'dff_m.map';
  die unless open DFF_MAP, "> $config_fnc[-1]";
  die unless print DFF_MAP "% dvipdfm(1) Type1 font map file\n";
  die unless print DFF_MAP "Z9dUmMy none z9dummy.pfa\n";
  # ^^^ This line is needed, because dvipdfm(1) tries to load fonts.map if
  # this file doesn't contain any entries.
} elsif ($opt_dr==DR_DVIPS) {
  push @config_fnc, 'dff_ps.map';
  die unless open DFF_MAP, "> $config_fnc[-1]";
  die unless print DFF_MAP "% dvips(1) Type1 font map file\n";
} elsif ($opt_dr==DR_PS2PK or $opt_dr==DR_XDVI or $opt_dr==DR_XDVICFG) {
  push @config_fnc, 'dff_psk.map';
  die unless open DFF_MAP, "> $config_fnc[-1]";
  die unless print DFF_MAP "% ps2pk(1)/xdvi(1)/mktexpk(1) Type1 font map file\n";
} elsif ($opt_dr==DR_PDFTEX) {
  push @config_fnc, 'dff_t.map';
  die unless open DFF_MAP, "> $config_fnc[-1]";
  die unless print DFF_MAP "% pdftex(1) Type1 font map file\n";
} else { die }
die unless print DFF_MAP "% created by $0\n% This is a generated file. Do not edit.\n";

# at Wed Jun 23 08:58:03 CEST 2004
# vvv copied from Fontmap.GS in Ghostscript 7.04
my %pfn_subst=qw(
URWBookmanL-DemiBold Bookman-Demi
URWBookmanL-DemiBoldItal Bookman-DemiItalic
URWBookmanL-Ligh Bookman-Light
URWBookmanL-LighItal Bookman-LightItalic
 
NimbusMonL-Regu Courier
NimbusMonL-ReguObli Courier-Oblique
NimbusMonL-Bold Courier-Bold
NimbusMonL-BoldObli Courier-BoldOblique
 
URWGothicL-Book AvantGarde-Book
URWGothicL-BookObli AvantGarde-BookOblique
URWGothicL-Demi AvantGarde-Demi
URWGothicL-DemiObli AvantGarde-DemiOblique
 
NimbusSanL-Regu Helvetica
NimbusSanL-ReguItal Helvetica-Oblique
NimbusSanL-Bold Helvetica-Bold
NimbusSanL-BoldItal Helvetica-BoldOblique
 
NimbusSanL-ReguCond Helvetica-Narrow
NimbusSanL-ReguCondItal Helvetica-Narrow-Oblique
NimbusSanL-BoldCond Helvetica-Narrow-Bold
NimbusSanL-BoldCondItal Helvetica-Narrow-BoldOblique
 
URWPalladioL-Roma Palatino-Roman
URWPalladioL-Ital Palatino-Italic
URWPalladioL-Bold Palatino-Bold
URWPalladioL-BoldItal Palatino-BoldItalic
 
CenturySchL-Roma NewCenturySchlbk-Roman
CenturySchL-Ital NewCenturySchlbk-Italic
CenturySchL-Bold NewCenturySchlbk-Bold
CenturySchL-BoldItal NewCenturySchlbk-BoldItalic
 
NimbusRomNo9L-Regu Times-Roman
NimbusRomNo9L-ReguItal Times-Italic
NimbusRomNo9L-Medi Times-Bold
NimbusRomNo9L-MediItal Times-BoldItalic
 
StandardSymL Symbol
 
URWChanceryL-MediItal ZapfChancery-MediumItalic
 
Dingbats ZapfDingbats
);

{ my $I=0;
  my %missing_fonts=%all_fonts;
  my %had_fonts;
  my %had_map;
  my %had_psfontnames;
  my $home=exists $ENV{HOME} ? "$ENV{HOME}/" : "";
  for my $maprel (@dp_maps) {
    # my $mapabs=getmap_absname($maprel);
    # Dat: `kpsewhich base/latex.ltx' finds latex.ltx, but we won't if arg contains slash
    my $mapabs;
    if ($maprel=~y@/@@) {
      if (!-f($mapabs=$maprel)) {
        warning ".map not found: $mapabs";
        next
      }
    } else {
      $mapabs=qx($dp_cmds[$I]);  chomp $mapabs;
      if (0==length($mapabs) or !-f $mapabs) { # myfonts.map -- become a warning at Tue Oct  7 16:05:02 CEST 2003
        my $cmd=$dp_cmds[$I];
        # vvv Dat: tetex 3.0 needs --format="map" instead of --format="other text files"
        if ($cmd!~s@--format="other text files"@--format="map"@ or (0*chomp($mapabs=qx($cmd))) or 0==length($mapabs) or !-f $mapabs) {
          warning ".map not found: $maprel ($dp_cmds[$I])";
          next
        }
      }
    }
    next if exists $had_map{$mapabs};
    $had_map{$mapabs}=1;
    info(substr($mapabs,0,length($home))eq$home ? "Processing map ~/".substr($mapabs,length($home))
      : "Processing map $mapabs");
    die unless open F, "< $mapabs"; while (<F>) {
      s@\A\s+@@; s@\s+\Z(?!\n)@@; s@\s+@ @g; # remove whitespace
      s@\s*%.*@@; remove comment
      next if !length;
      # A typical entry in a dvips/pdftex psfonts.map file:
      #   pcrr8rn Courier ".85 ExtendFont .167 SlantFont TeXBase1Encoding ReEncodeFont" <8r.enc <pcrr8a.pfb
      # This should be translated to a dvipdfm t1fonts.map file as:
      #   pcrr8rn 8r pcrr8a.pfb -e .85 -s .167
      # Another alternative translation:
      #   pcrr8rn 8r pcrr8a -s .167 -e .85
      # The other direction (TeXBase1Encoding) can be deduced from the contents
      # of `kpsewhich 8r.enc`.
      my $ExtendFont; # or "-e .85"
      my $SlantFont;  # or "-s .167"
      my $outlinename=""; # *.pfa or *.pfb
      my $encodingfn="none"; # "8r", without .enc
      my $afmname;
      my $texfontname;
      my $psfontname;
      my $encname;
      my $outlinefmt='type1';
      warning "added fake fontname $1-dff" if s/\A(\S+) "/$1 $1-dff "/ and $opt_dr==DR_DVIPS;
      # ^^^ Dat: fix buggy pdftex.map (buggy for dvips) line in teTeX 2: bchbo8r " .167 SlantFont TeXBase1Encoding ReEncodeFont " <8r.enc <bchb8a.pfb
      # ^^^ !! this fix isn't appropriate for dvips(1), because it needs the real /FontName -- SUXX
      # ^^^ This works (temporarily) for lakk, because our .map files override
      #     with good fontname.
      if (/["<]/ or /[.](?:pf[ab]|ttf)/ or /\A(\S+) ([A-Z]\S{3,})\Z(?!\n)/) { # dvips/pdftex .map entry
        # ^^^ Dat: there can be font file lines without `<' (meaning --dff-subset=none)
        #die "\n\n$mapabs:($_)\n" if /rpxpplr/;
        next if !s/\A(\S+) (\S+)\s+//; # silently ignore short lines -- without <x.pgb etc.
        ($psfontname,$texfontname)=($2,$1);
	die if $texfontname=~m@[^\w-]@; # Dat: tett1200-shorthyp.pfb
	# Dat: `md-chb7t ?????? <md-chb7t.pfb'
	next if $psfontname!~/[^?]/;
	die "bad PS fontname: $psfontname\n" if $psfontname=~m@[^-.+\w]@; # Imp: be more permissive
        #print "[$psfontname] {$texfontname} ($_)\n";
	#die $_ if $texfontname=~/bchbo8r/;
        $_.=" ";
        if (s/"([^"]*)"//) {
          my $qq=$1;
          $ExtendFont=$1 if $qq=~/(-?[\d.]+)\s+ExtendFont\b/;
          $SlantFont =$1 if $qq=~/(-?[\d.]+)\s+SlantFont\b/;
          $encname=$1 if $qq=~/(\S+)\s+ReEncodeFont\b/;
        }
	#** From pdftex-t.pdf:
	#** '': --dff-subset=none (don't embed fonts)
	#** '<': --dff-subset=subset (subset embedded fonts)
	#** '<<': --dff-subset=whole (don't subset embedded fonts)
	my $origoprefix='<';
	$outlinefmt='type1';
	if (s@(<*)(\S+[.](pf[ab]|[to]tf)) @ @i) { # ttf
          $outlinename=$2;
	  $origoprefix=$1 if $1 eq '<<' or $1 eq '<';
	  $outlinefmt='truetype' if lc($3) eq 'ttf';
	}
        $encodingfn=$1 if s@<(\S+)[.]enc @ @i;
        if (0==length($outlinename)) {
	  # !! why? If we don't want to download it, then we don't.
	  #    we especially don't want the nonexisting rpxpplr for rpxpplr.pfb
	  # !! fix # Valid settings are true / false:
          #     dvipsDownloadBase35 false -> true
	  #    by a combination of pdftex.map and dvips.map 
          # Try to guess .pfb from TeX fontname, for base 35 fonts. Do it
          # before applying %pf_subst
          # pcrb8r -> pcrm8a.pfb, ptmr8y -> ptmr8a.pfb, psyr -> psyr.pfb
          $outlinename=$texfontname;
          $outlinename=~s@8[ry]\Z(?!\n)@8a@;
          $outlinename.=".pfb";
        }
        if (exists $pf_subst{$outlinename}) {
          ## print "substituting $outlinename -> $pf_subst{$outlinename}\n";
          $outlinename=$pf_subst{$outlinename};
          if (exists $pf_subst{$outlinename}) {
            die unless $pf_subst{$outlinename} eq $outlinename;
            # possibly skippable base font for DR_PDFTEX
            if (!defined $ExtendFont and !defined $SlantFont) {
	      $psfontname=$pfn_subst{$psfontname} if exists $pfn_subst{$psfontname};
	      #print STDERR ":$psfontname\n";
              $outlinename=""; # don't set $psfontname
            }
          } else {
            # vvv important to set $psfontname, so dvipdfm will embed Times-Bold instead of NimbusRomNo9L-Medi
            ($psfontname,$outlinename)=($outlinename,"") if $outlinename=~/^[A-Z][^.]*\Z(?!\n)/; # a font from the base 35
          }
        }
        $afmname=$outlinename; setext $afmname, '.afm';
        ## print "$texfontname $outlinename;;\n";
      } elsif (/^(\S+)\s/) { # dvipdfm-style .map entry; remove `-r' from the end
        my @L=split' ', $_;
        #** TeX-name encoding AFM-name PFB-name (see psbase14.map for syntax)
        my @M=('-TeX-name-','default','default','default');
        my $I;
        my $J;
        for ($I=$J=0;$I<@L;$I++) {
             if ($L[$I]eq'-e' and $I<$#L) { $ExtendFont=$L[++$I] }
          elsif ($L[$I]eq'-s' and $I<$#L) { $SlantFont=$L[++$I] }
          elsif ($L[$I]eq'-r') { } # remove this; Imp: other `-...' options
          else { $M[$J++]=$L[$I] }
        }
        $M[1]='none' if $M[1] eq 'default';
        $M[2]=$M[0] if $M[2] eq 'default';
        $M[3]=$M[2] if $M[3] eq 'default';
        ($texfontname,$encodingfn,$afmname,$outlinename)=@M;
        $encodingfn=~s@[.]enc\Z(?!\n)@@;
        $encodingfn="none" if $encodingfn eq 'ot1alt' or $encodingfn eq 'ot1r';
        # ^^^ these bugfixing encodings are not needed anymore (see
        # dvipdfm's cmr.map for comments)
        if ($afmname eq $outlinename and $afmname=~/^[A-Z][^.]*\Z(?!\n)/) {
          # no:  ecrm2488 cm-super-t1 sfrm2488                                                   
          # yes: phvr8r    8r    Helvetica
          $psfontname=$afmname;
          $afmname=$outlinename="";
          ## print "$psfontname $texfontname;;\n";
        } else {
          addext $afmname, '.afm';
          addext $outlinename, '.pfb';
        }
      } else {
        # silently ignore the syntax error
        next
      }
      next if exists $had_fonts{$texfontname};
      # ^^^ font already defined -- silently ignore redefinition.
      # Dat: When there are multiple definitions for the same font, the fist
      #      one takes precedence (priority), so the second font entry in the
      #      same or different .map file doesn't override the first one.
      #      The order of command line options is significant. Thus:
      #      --dff-dvips-maps=1: look dvips maps, then pdftex maps
      #      --dff-dvips-maps=1 --dff-pdftex-maps=0: look dvips maps only
      #      --dff-map=foo.map: look foo.map, then pdftex maps
      #      --dff-pdftex-maps=1 --dff-map=foo.map: look pdftex maps, then foo.map
      delete $missing_fonts{$texfontname};
      $psfontname="Z" if 0!=length($outlinename) and $opt_dr==DR_PDFTEX;
      # ^^^ pdfTeX uses $psfontname only for distinguishing the base 14
      #     fonts from each other and other fonts. If we didn't set to 'Z'
      #     we must change NimbusRomNo9L-Regu to Times-Roman etc. when
      #     $outlinename eq"" (ne?)
      # ^^^ Dat: the `0!=length($outlinename)' check is there so that we
      #     change the font name to `Z' when an outline font is available
      $psfontname="" if $opt_dr==DR_PDFTEX and $outlinefmt eq 'truetype';
      # ^^^ at Sat Mar 24 17:40:00 CET 2007
      #     added TTF check to avoid emitting `/BaseFont /Z' for TrueType
      #     fonts, which makes `xpdf -t1lib yes -freetype no' mad.
      #     Dat: `xpdf -t1lib yes -freetype no' won't work anyway, because
      #     t1lib cannot render Type1 fonts.
      if (defined $psfontname) {
      } elsif (substr($encodingfn,0,9) eq "cm-super-") {
	# Educated guess for the /FontName of cm-super fonts
	$psfontname=uc($texfontname);
	substr($psfontname,0,2)="SF";
      } else {
	next # Imp: open each font file; missing from dvipdfm .map file :-(
      }
      if ($opt_dr==DR_DVIPDFM) {
        $ExtendFont=defined($ExtendFont) ? " -e $ExtendFont" : "";
        $SlantFont=defined($SlantFont) ? " -s $SlantFont" : "";
        if (0==length($outlinename)) {
          print DFF_MAP "$texfontname $encodingfn $psfontname$ExtendFont$SlantFont\n";
        } else {
          # Dat: we won't dump $afmname before $outlinename here, because
          #      dvipdfm has problems reading it back
          print DFF_MAP "$texfontname $encodingfn $outlinename$ExtendFont$SlantFont\n";
        }
      } elsif ($opt_dr==DR_DVIPS or $opt_dr==DR_PS2PK or $opt_dr==DR_PDFTEX
       or $opt_dr==DR_XDVI or $opt_dr==DR_XDVICFG) {
        if ($opt_dr==DR_PDFTEX and 0==length $outlinename and (defined $ExtendFont or defined $SlantFont)) {
          info "no filename for must-embed font, skipping: $texfontname";
          next
        }
	if ($opt_dr==DR_DVIPS) {
	  if (exists $had_psfontnames{$psfontname} and $had_psfontnames{$psfontname} ne $outlinename) {
	    # at Wed Mar 10 18:09:08 CET 2004
	    # Dat: dvips(1) may embed any of t1xtt.pfb and t1xtt-shorthyp.pfb,
	    #      but not both, if they share the same /FontName (t1xtt.pfb)
	    warning "dvips can't have files $had_psfontnames{$psfontname} and $outlinename for /FontName $psfontname";
	  }
	  # !! $had_psfontnames{$psfontname}=$outlinename;
	}
        my @quoted;
	# vvv Dat: order of ExtendFont, SlantFont is irrelevant for dvips(1) (tested)
        push @quoted, $ExtendFont, 'ExtendFont' if defined $ExtendFont;
        push @quoted,  $SlantFont,  'SlantFont' if defined  $SlantFont;
	my $this_opt_subset=$opt_subset;
	$this_opt_subset='subset' if defined $ExtendFont or defined $SlantFont;
	# ^^^ Dat: pdflatex: invalid entry for `rtxbsssl': SlantFont/ExtendFont can be used only with embedded T1 fonts
        if ($encodingfn ne 'none') {
          if (!defined $encname) {
            $encname=getenc_encname("$encodingfn.enc");
            next if !defined $encname;
          }
          push @quoted, $encname, 'ReEncodeFont';
          $encodingfn=" <$encodingfn.enc";
        } else { $encodingfn="" }
	# !! $opt_subset = unchanged
	my $oprefix=($this_opt_subset eq 'unchanged' ? '<' :
	  $this_opt_subset eq 'subset' ? '<' :
	  $this_opt_subset eq 'whole' ? '<<' :
	  $this_opt_subset eq 'none' ? '' : '<');
	$outlinename='' if $oprefix eq '' and $opt_dr==DR_DVIPS; # Dat: required by dvips and not required by pdftex
        $outlinename=length($outlinename) ? " $oprefix$outlinename" : "";
        my $q=@quoted ? qq{ "@quoted"} : "";
        print DFF_MAP "$texfontname $psfontname$q$encodingfn$outlinename\n";
      }
      $had_fonts{$texfontname}=1;
    }
    die unless close F;
  } continue { $I++ }
  for my $fontn (keys %missing_fonts) {
    my $abs=qx(kpsewhich -- "$fontn.vf"); chomp($abs);
    delete $missing_fonts{$fontn} if 0!=length($abs); # Imp: also check whether referenced (and used) fonts exists, i.e. vftovp output: `  (FONTNAME ...)'
  }
  if (%missing_fonts) {
    # Dat: possibilities: virtual (.vf), bitmap (.*pk), Type1 (.pfa, .pfb),
    #      TrueType (.ttf)
    # Dat: this is only a preliminary warning; the trial run will reveal
    #      really missing fonts. Possible difference: .vf referring rto .pfb
    warning "a non-Type1 font may be virtual, bitmap, TrueType etc.";
    warning "no such Type1 font(s): ".join(" ",sort keys %missing_fonts);
  }
}

if ($opt_dr==DR_XDVI or $opt_dr==DR_XDVICFG) {
  die unless print DFF_MAP "Z9dUmMy Z9dUmMy\n";
  # ^^^ Dat: buggy xdvi(k)-22.40 doesn't know about last line of the .map,
  #     so we append a line by hand.
}

die unless close DFF_MAP;

#** @return list to be push()ed to @ty_local_conf;
sub mk_xdvi_config() {
  my @ret_local_conf;
  my $confabs=getconf_absname("xdvi.cfg","xdvi");
  # Imp: use `dvipdfm -f filename' instead of cloning
  info "Cloning $confabs";
  push @config_fnc, 'config.xdvi';
  die unless open CONF, "> config.xdvi";
  die unless print CONF "% xdvi(1) config file created by $0
% This is a generated file. Do not edit.\n";
  die unless open F, "< $confabs";
  while (<F>) { print CONF if !/^dvipsmap\b/ }
  die unless close F;
  die unless print CONF "\ndvipsmap ps2pk.map\n";
  # ^^^ Dat: ps2pk(1) called by xdvi(1) needs this anyway
  die unless close CONF;
  die unless open CONF, "< config.xdvi";
  push @ret_local_conf, "xdvi.cfg"; unlink $ret_local_conf[-1];
  die unless open F, "> $ret_local_conf[-1]";
  my $S; print F $S while sysread CONF, $S, 4096;
  die unless close F;
  die unless close CONF;

  info "Cloning dff_psk.map to ps2pk.map";
  die unless open CONF, "< dff_psk.map";
  push @ret_local_conf, "ps2pk.map"; unlink $ret_local_conf[-1];
  die unless open F, "> $ret_local_conf[-1]";
  print F $S while sysread CONF, $S, 4096;
  die unless close F;
  die unless close CONF;
  @ret_local_conf
}

if (!defined $dviname) { # Dat: for DR_PS2PKG and DR_XDVICFG
  info "Created font map file: $config_fnc[-1]";
  mk_xdvi_config() if $opt_dr==DR_XDVICFG;
  exit;
}
# vvv Dat: usually not reached
if ($opt_dr==DR_PS2PK or $opt_dr==DR_XDVICFG) { info "Stopping driver: $opt_driver\n"; exit }

# --- Fix paper size for dvips(1)

my @special_filters;

#** @param $_[0] DVI file name
#** @return () or (WD,HT) from \special{papersize=WD,HT}
sub get_dvi_papersize($) {
  error "DVI not found: $_[0]" if! open DVIF, "< $_[0]";
  my $head;
  if (15!=read DVIF, $head, 15) { IOerr: close DVIF; return () } # $bbi->{Error}="IO: $!"; goto done
  # ($dummy,$bbi->{'Info.version_id'},$bbi->{'Info.numerator'}, $bbi->{'Info.denominator'},$bbi->{'Info.magnification'})=unpack('CCNNN',$head);
  my $dummy=vec($head,14,8);
  my $bbi_jobname; # unused
  my $bbi_page1_nr;
  goto IOerr if $dummy!=read DVIF, $bbi_jobname, $dummy;
  my($tag,$action);
  my @actions=(0)x256; # skip that char
  $actions[139]=15; # Bop
  # vvv Dat: 223 is TRAILER, but also FONT_52
  @actions[248,249,140]=(16,16,16,16); # stop parsing file
  @actions[128,133,143,148,153,157,162,167,235]=(1,1,1,1,1,1,1,1,1); # read 1 extra bytes
  @actions[129,134,144,149,154,158,163,168,236]=(2,2,2,2,2,2,2,2,2); # read 2 extra bytes
  @actions[130,135,145,150,155,159,164,169,237]=(3,3,3,3,3,3,3,3,3); # read 2 extra bytes
  @actions[131,136,146,151,156,160,165,170,238]=(4,4,4,4,4,4,4,4,4); # read 2 extra bytes
  @actions[132,137]=(8,8); # read 8 extra bytes
  @actions[243,244,245,246]=(17,18,19,20); # Fnt_def
  @actions[239,240,241,242]=(33,34,35,26); # Special (XXX)
  my @L;
  while (1) {
    #info tell DVIF;
    goto IOerr if !defined($tag=getc(DVIF)); # Dat: EOF is error
    #info ord $tag;
    $tag=$actions[ord($tag)];
    if ($tag==0) {
    } elsif ($tag==16) {
      last
    } elsif ($tag==15) { # Bop
      last if defined $bbi_page1_nr;
      goto IOerr if 44!=read DVIF, $dummy, 44;
      $bbi_page1_nr=unpack "N", $dummy;
    } else {
      # read number of ($tag&15) bytes in MSBfirst byte order
      $dummy="\0\0\0\0";
      goto IOerr if ($tag&15)!=read DVIF, $dummy, ($tag&15), 4;
      $dummy=unpack("N",substr($dummy,-4));
      if ($tag>=33) { # Special
        goto IOerr if $dummy!=read DVIF, $tag, $dummy;
        $tag=~s@\s+\Z(?!\n)@@;
	# info "DVI \\special ($tag)";
	if ($tag=~m@\Apapersize\s*=\s*(\S+)\s*,\s*(\S+)\s*\Z(?!\n)@) {
	  info "overriding papersize=" if @L;
	  @L=($1,$2)
	} elsif ($tag=~m@\A\!\%filter:\s*(.*)\Z(?!\n)@) {
	  push @special_filters, $1
	}
	# info tell DVIF;
        # if ($L[0] eq 'landscape') # Imp: set papersize=11in,8.5in with low prio?
      } elsif ($tag>=17) { # Fnt_def
        goto IOerr if 14!=read DVIF, $tag, 14;
        $dummy=vec($tag,12,8)+vec($tag,13,8);
        goto IOerr if $dummy!=read DVIF, $tag, $dummy;
      }
    } # IF 
  } # WHILE
  close DVIF;
  @L # no useful \special found (); or (width,height)
}

# Imp: integrate justlib2/Htex/dimen.pm
my %bp_mul;
{ no integer; %bp_mul=(
  'bp'=>1, # 1 bp = 1 bp (big point)
  'in'=>72, # 1 in = 72 bp (inch)
  'pt'=>72/72.27, # 1 pt = 72/72.27 bp (point)
  'pc'=>12*72/72.27, # 1 pc = 12*72/72.27 bp (pica)
  'dd'=>1238/1157*72/72.27, # 1 dd = 1238/1157*72/72.27 bp (didot point) [about 1.06601110141206 bp]
  'cc'=>12*1238/1157*72/72.27, # 1 cc = 12*1238/1157*72/72.27 bp (cicero)
  'sp'=>72/72.27/65536, # 1 sp = 72/72.27/65536 bp (scaled point)
  'cm'=>72/2.54, # 1 cm = 72/2.54 bp (centimeter)
  'mm'=>7.2/2.54, # 1 mm = 7.2/2.54 bp (millimeter)
) }
#** @param $_[0] a string
#** @return value if $_[0] represents a floating point or integer numeric
#**   constant in the C language (without the LU etc. modifiers) -- or undef
sub c_numval($) {
  my $S=$_[0];
  no integer; # very important; has local scope
  return 0+$S if $S=~/\A[+-]?(?:[0-9]*\.[0-9]+(?:[eE][+-]?[0-9]+)?|[0-9]+\.?)\Z(?!\n)/;
  undef
}
#** @param $_[0] a (real or integer) number, optionally postfixed by a
#**        TeX dimension specifier (default=bp)
#** @return the number in bp, or undef
sub dimen2bp($) {
  no integer;
  my $S=$_[0];
  my $mul;
  $mul=$bp_mul{$1} if $S=~s/\s*([a-z][a-z0-9]+)\Z(?!\n)// and exists $bp_mul{$1};
  my $val=c_numval($S);
  $val*=$mul if defined $val and defined $mul;
  $val
}

sub round_up($) {
  no integer;
  # Dat: see also myfloor() and myceil() in a2ping.pl. This should be similar
  #      to myceil()
  # Dat: round up 791.99999003736 -> 792
  $_[0] < 0 ? -int(-$_[0]+.05) : int($_[0]+.95)
}

my $dvips_papersize_config="";
if ($opt_dr==DR_DVIPS) {
  my @L=get_dvi_papersize $dviname; # always do it to process \specials
  if (grep { /\A--dff-force-paper=(.*)/s and opt_val_istrue($1) } @opts) {
    if (@L) {
      info "Paper size in DVI is wd=$L[0] ht=$L[1]";
      my($wr,$hr);
      # Imp: gtexbin/dvips.pl, do some well-kown paper size names, not just `special'
      #die "(@L)\n";
      $wr=dimen2bp $L[0]; error "bad wd" if !defined $wr;
      $hr=dimen2bp $L[1]; error "bad ht" if !defined $hr;
      for my $filter (@special_filters) { # Dat: @special_filters from get_dvi_papersize()
	if ($filter=~/\A: force_papersize\s+(\S+)\s+(\S+)/) {
	  # Dat: don't change $L[0], $L[1]
	  my @LL=($1,$2);
          info "Forcing paper size wd=$LL[0] ht=$LL[1]";
	  $wr=dimen2bp $LL[0]; error "bad wd" if !defined $wr;
	  $hr=dimen2bp $LL[1]; error "bad ht" if !defined $hr;
	}
      }
      my $wu=round_up($wr);
      my $hu=round_up($hr);
      $dvips_papersize_config="\@
\@ special $L[0] $L[1]
\@+ ! \%\%DocumentPaperSizes: Special
\@+ \%\%PaperSize: Special
\@+ \%\%BeginPaperSize: Special
\@+ /setpagedevice where {
\@+   pop 1 dict dup /PageSize [ $wu $hu ] put setpagedevice
\@+ } {
\@+   statusdict /setpage known
\@+     { statusdict begin $wu $hu 0 setpage end } if
\@+ } ifelse
\@+ \%\%EndPaperSize\n";
    } else { warning "\\special{papersize=...} is missing from DVI" }
  }
}

# --- Override the DR_* `config' file to use dff_*.map

my @ty_local_conf; BEGIN{@ty_local_conf=()}
# vvv even on a non-fatal signal
END {unlink @ty_local_conf;1}

my @ty_temp;
END {unlink @ty_temp;1}
$SIG{TERM}=$SIG{HUP}=$SIG{INT}=sub{exit 99}; # run the END {...} subs

if ($opt_dr==DR_DVIPDFM) {
  my $confabs=getconf_absname("config","dvipdfm");
  # Imp: use `dvipdfm -f filename' instead of cloning
  info "Cloning $confabs";
  push @config_fnc, 'config.dfm';
  die unless open CONF, "> config.dfm";
  die unless print CONF "% dvipdfm(1) config file created by $0
% This is a generated file. Do not edit.\n";
  die unless open F, "< $confabs";
  while (<F>) { print CONF if !/^\s*f\s+(\S+)/i and !/^\s*%/ and /\S/ }
  die unless close F;
  die unless print CONF "\nf dff_m.map\n";
  die unless close CONF;
  die unless open CONF, "< config.dfm";
  push @ty_local_conf, "config"; unlink $ty_local_conf[-1];
  die unless open F, "> config";
  my $S; print F $S while sysread CONF, $S, 4096;
  die unless close F;
  die unless close CONF;
} elsif ($opt_dr==DR_DVIPS) {
  # Dat: don't ignore case for `p ' when removing
  # Dat: dvips(1) doesn't even try to open psfonts.map in this case
  push @config_fnc, 'config.dfp';
  die unless open CONF, "> config.dfp";
  die unless print CONF "% dvips(1) config file created by $0
% This is a generated file. Do not edit.\np dff_ps.map\n$dvips_papersize_config";
  die unless close CONF;
} elsif ($opt_dr==DR_XDVI) {
  push @ty_local_conf, mk_xdvi_config();
} elsif ($opt_dr==DR_PDFTEX) {
  # Imp: add PDF-1.2 compatibility to `config'
  my $confabs=getconf_absname_try("pdftex.cfg","pdftex");
  if (defined $confabs) { # tetex 2.0
    info "Cloning $confabs";
    push @config_fnc, 'config.dft';
    die unless open CONF, "> config.dft";
    die unless print CONF "% pdftex(1) config file created by $0\n".
      "% This is a generated file. Do not edit.\n";
    die unless open F, "< $confabs";
    while (<F>) { print CONF if !/^\s*map\s+(\S+)/i and !/^\s*%/ and /\S/ }
    die unless close F;
    die unless print CONF "\nmap dff_t.map\n";
    die unless close CONF;

    die unless open CONF, "< config.dft";
    push @ty_local_conf, "pdftex.cfg"; unlink $ty_local_conf[-1];
    die unless open F, "> pdftex.cfg";
    my $S; print F $S while sysread CONF, $S, 4096;
    die unless close F;
    die unless close CONF;
  } else { # tetex 3.0
    # Dat: change @ARGV from '--pdftexargs foofile' to
    #      `--pdftexargs \pdfmapfile{dff_t.map} \input foofile
    # Dat: change 'foofile' to '\pdf
    if (!grep { /\A\\input\b/ } @ARGV) {
      splice(@ARGV,-1,0,"\\input");
    }
    my $I=0;
    $I++ while defined $ARGV[$I] and substr($ARGV[$I],0,1) eq '-';
    splice(@ARGV,$I,0,"\\pdfmapfile{dff_t.map}");
    # die "@ARGV";
  }
} else { die }

# --- Run DR_* to acquire PFB and PK fontnames (first pass)
# Dat: we cannot use %all_fonts here, because PFB files used by virtual fonts
#      and external MetaPost EPS images have to be also included

my %pks; # "ccr10" => "/.../ccr10.600pk"
#** @param $_[0] fontname (without .pk)
#** @param $_[1] filename ("/.../ccr10.600pk") or '.'
sub found_pk($$) {
  my($fon,$fin)=@_;
  warning "bitmap font: $fon => $fin" if !exists $pks{$fon};
  # *.600pk and *.1200pk should not be considered a multiple-definition
  warning "PK multiply defined: $fin" if exists $pks{$fon} and
    substr($pks{$fon},0,rindex($pks{$fon},'.')) ne substr($fin,0,rindex($fin,'.'));
  
  $pks{$fon}=$fin;
}

my %pfs; # "cmr10.pfb" => "cmr10.pfb", "cour.pfa" => "cour.pfa", "lfr.pfb" => "lfr.pfb", "bchb8a.pfb" => "bchb8a.pfb"
#** @param $_[0] fontname with/without .pfb or .pfa, without directory
#** @param $_[1] filename, abs or rel
sub found_pf($$) {
  my($fon,$fin)=@_;
  warning "$fin multiply defined: $fon" if exists $pfs{$fon};
  $pfs{$fon}=$fin;
}

my $outname; # output.ps or output.pdf
my $dff_fnt=exists $ENV{DFF_TEMP_FNT} ? $ENV{DFF_TEMP_FNT} : "dff.fnt";
$dff_fnt=~s@/+\Z(?!\n)@@;
$dff_fnt=~s@//+@/@g;
END { unlink $outname if defined $outname; 1 }
delete $ENV{T1FONTS} if exists $ENV{T1FONTS} and index($ENV{T1FONTS},$dff_fnt)>=0;

#** Opens, but doesn't close F.
#** @param $_[0] UNIX shell command line
#** @return string of STDOUT and STDERR grabbed
sub pipe_grab($) {
  select(STDERR); $|=1;  select(STDOUT); $|=1;
  my $ARGS=$_[0];
  my $progname=($ARGS=~/^(\S+)/) ? $1 : "?";
  error "pipe to $progname failed" unless open F, "$ARGS 2>&1|";
  my $grab="\n";
  my $S;
  while (sysread(F, $S, 4096)) {
    $S=~y@\r@@d;
    $S=~s@\A\n+@@ if substr($grab,-1,1)eq"\n";
    $S=~s@\n\n+@\n@g;
    ## $S="{$S}";
    $grab.=$S;
    print $S;
  }
  if (substr($grab,-1,1)ne"\n") { $grab.="\n"; print "\n" }
  $grab
}

sub prepend_curdir($) {
  return 0==length$_[0] ? '.' : substr($_[0],0,2)eq'.:' ? $_[0] : ".:$_[0]"
}

# Now fill %pks, %pfs, $outname and @dvips_full_argt

my $noq_p=0;

my @dvips_full_argt;
if ($opt_dr==DR_DVIPDFM) { 
  my $ARGS=join('  ', map { shq $_ } @ARGV);
  $ARGS="-v $ARGS" if !grep {$_ eq '-v'} @ARGV;
  $ARGS="dvipdfm  $ARGS";
  my $tph;
  my $tph_save;
  #** The stdout+stderr of dvipdfm and subprocesses.
  my $grab;
  if ($opt_onepass and 0!=length($tph=qx(kpsewhich --progname=dvipdfm --expand-var=\\\$T1FONTS 2>/dev/null))) {
    chomp $tph;
    # Dat: T1FONTS is something like '.:{/home/joe/texmf,/usr/local/share/texmf...}/fonts/type1,...{...}/fonts/hbf'
    # Dat: TEXPSHEADERS is something like '.:{/home/guests/pts/texmf,/usr/local/share/texmf,/usr/local/lib/texmf,!!/usr/share/texmf}/{dvips,pdftex,tex,fonts/type1}//'
    $tph_save=$ENV{T1FONTS};
    chomp $tph;
    $tph=~s@[!]+/@/@g; # strange, doesn't work: !/usr/share/texmf
    $ENV{T1FONTS}="$dff_fnt:$tph";
    # Imp: verify opened fonts with strace(1)
    info "Running first pass: $ARGS";
    $grab=pipe_grab($ARGS); 
    # $grab=pipe_grab("strace -eopen -oz $ARGS"); # OK
    if (!defined$tph_save) { delete $ENV{T1FONTS} } else { $ENV{T1FONTS}=$tph_save }
  } else {  
    info "Querying fonts with $ARGS";
    $grab=pipe_grab($ARGS);
    # ^^^ Dat: the `... -> ...' filename line is printed early to the terminal,
    # but since now the output goes to a pipe, buffering may cause it to print
    # late
  }
  $outname=($grab=~/ -> (.*)\n/) ? $1 : undef;
  error "missing, ungeneratable fonts for dvipdfm" if $grab=~/^Maybe in the future, I'll substitute some other font[.]$/m;
  
  error "dvipdfm failed" if !close F;
  error "pdfname not found" if !defined $outname;

  my $fn;
  # Dat: no virtual fonts inside $grab -- they have already been resolved
  while ($grab=~/[(](PF[AB]):([^)\n]+)[)]/g) {
    ## print "PFB $2.\n";
    $fn=$2; addext $fn, '.'.lc($1);
    found_pf($2,$fn);
  }
  while ($grab=~m@[(]((?:/|[a-zA-Z]:\\)[^)\n]+[/\\]([^)/\\\n]+)[.]\d+pk)[)]@g) {
    # ^^^ e.g /var/spool/texmf/pk/ljfour/public/concrete/ccr10.600pk
    found_pk($2,$1);
  }
} elsif ($opt_dr==DR_DVIPS) { 
  # Dat: dvips(1) reports Type1 fontnames used to STDOUT, and bitmap fontnames
  #      used to its output. We concatenate these two with `dvips "-o|..."'
  @dvips_full_argt=qw(dvips);
  for my $opt (@opts) {
    # Dat: for debugging: dff.pl --dff-driver='strace -e open dvips' dvips t
    @dvips_full_argt=split/\s+/,$1 if $opt=~/\A--dff-driver=(.*)/s;
  }
  undef $outname;
  my $I;
  for ($I=0;$I<@ARGV;$I++) {
    if ($ARGV[$I] eq '-o') { error 'premature dvips -o' if ++$I==@ARGV; $outname=$ARGV[$I] }
    elsif (substr($ARGV[$I],0,2) eq '-o') { $outname=substr($ARGV[$I],2) }
    # Dat: dvips doesn't support `--')
    elsif ($ARGV[$I] eq '-' or substr($ARGV[$I],0,1)ne'-') { last } # end of options
    else { push @dvips_full_argt, $ARGV[$I] }
  }
  if (!defined$outname or !length$outname) { $outname=$dviname; setext $outname, '.ps' }
  push @dvips_full_argt, "-Pdfp", # Dat: make it the last, so our `p dff_ps.map' overrides all other fonts
    "-o$outname", @ARGV[$I..$#ARGV]; # force it, because some have `-o|lpr' in config.ps
  # ^^^ Dat: we could have also forced `-o ""'
  my $ARGS=join('  ', map { shq $_ } @dvips_full_argt);
  my($tph_save,$tco_save);
  my $grab;
  # Dat: tetex-1.x needs TEXPSHEADERS, tetex-2.x (pirospottyos.cs.bme.hu) needs TEXCONFIG
  my $tph=qx(kpsewhich --progname=dvips --expand-var=\\\$TEXPSHEADERS 2>/dev/null); chomp $tph;
  my $tco=qx(kpsewhich --progname=dvips --expand-var=\\\$TEXCONFIG    2>/dev/null); chomp $tco;
  ## die $tph; # {/home/guests/pts/texmf,/usr/local/share/texmf,/usr/local/lib/texmf,!!/usr/share/texmf}/{dvips,pdftex,tex,fonts/type1}//
  error 'missing $TEXPSHEADERS and $TEXCONFIG' if 0==length$tph and 0==length$tco;
  $ENV{TEXPSHEADERS}=$tph=prepend_curdir($tph);
  $ENV{TEXCONFIG}   =$tco=prepend_curdir($tco);
  # ^^^ fix teTeX dvips(1) not looking for config.ps etc. in curdir
  if ($opt_onepass) {
    $tph_save=$ENV{TEXPSHEADERS};
    $tco_save=$ENV{TEXCONFIG};
    delete $ENV{T1FONTS};
    # vvv Dat: we really don't want to remove fonts/type1 here -- dff.fnt has
    #     priority over it anyway. And removing fonts/type here would mean
    #     that fonts won't get embedded with dff-type1fix=0
    #warning 'cannot remove `fonts/type1\' from $TEXPSHEADERS' if
    #  scalar(grep { /\A--dff-type1fix=(.*)/s and opt_val_istrue($1) } @opts)
    #  and $tph!~s@,fonts/type1[}]@}@g;
    $tph=~s@[!]+/@/@g; # strange, doesn't work: !/usr/share/texmf
    $ENV{TEXPSHEADERS}="$dff_fnt:$tph";
    $ENV{TEXCONFIG}   ="$dff_fnt:$tco";
    # Imp: verify opened fonts with strace(1)
    info "TEXPSHEADERS=$ENV{TEXPSHEADERS}";
    info "TEXCONFIG=$ENV{TEXCONFIG}";
    info "Running first pass: $ARGS";
    $grab=pipe_grab($ARGS);
    if (!defined$tph_save) { delete $ENV{TEXPSHEADERS} } else { $ENV{TEXPSHEADERS}=$tph_save }
    if (!defined$tco_save) { delete $ENV{TEXCONFIG}    } else { $ENV{TEXCONFIG   }=$tco_save }
  } else { # change filename
    $opt_onepass=0;
    # Dat: the DVIPSBitmapFont lines will appear on the screen; ugly.
    my $bitmap_pipe=q~-o"|perl -ne BEGIN\{\$\|=1\}print,if/^%DVIPSBitmapFont:/"~;
    die unless $ARGS=~s^\A(\S+\s+\S+\s+)\S+^$1$bitmap_pipe^;
    info "Querying fonts with $ARGS";
    $grab=pipe_grab($ARGS);
  }
  error "dvips failed" if !close F;
  error "dvips cannot find ./config.dfp" if $grab=~/^.*?: warning: no config file for `dfp'$/m; # Dat: tetex-2.0 dvips error msg
  if ($opt_onepass) {
    error "outfile of dvips missing: $outname" if! open F, "< $outname";
    while (<F>) {
      found_pk $1, '.' if m@^%DVIPSBitmapFont:\s+\S+\s+(\S+)\s+\S+\s+\S+$@;
    }
    die unless close F;
  } else {
    # vvv Dat: %... is intermixed to the normal STDOUT (stdio 4k buffering)
    $grab=~s@%DVIPSBitmapFont:\s+\S+\s+(\S+)\s+\S+\s+\S+\n@ found_pk $1, '.' @ge;
  }    
  while ($grab=~/[<]([^<>\n]+[.]pf[ab])[>]/gi) { found_pf $1, $1 }
  warning "dvips hasn't recognised our paper size" if
    $grab=~/\sno match for special paper size found; using default\b/;
  ## undef $outname; die 42;
} elsif ($opt_dr==DR_PDFTEX) {
  my $ARGS=join('  ', map { shq $_ } ($opt_driver, @ARGV));
  undef $outname;
  my $grab;
  my $tph;
  my $tph_save;
  if ($opt_onepass and 0!=length($tph=qx(kpsewhich --progname='$opt_driver' --expand-var=\\\$T1FONTS 2>/dev/null))) {
    chomp $tph;
    $tph_save=$ENV{T1FONTS};
    chomp $tph;
    $tph=~s@[!]+/@/@g; # strange, doesn't work: !/usr/share/texmf
    $ENV{T1FONTS}="$dff_fnt:$tph";
    # Dat: don't need strace(1), expect <dff.fnt/*> in $grab
    info "Running first pass: $ARGS";
    # $grab=pipe_grab($ARGS); 
    #$grab=pipe_grab("strace -eopen -oz $ARGS"); # OK
    $grab=pipe_grab($ARGS);
    if (!defined$tph_save) { delete $ENV{T1FONTS} } else { $ENV{T1FONTS}=$tph_save }
  } else {  
    info "Querying fonts with $ARGS";
    $grab=pipe_grab($ARGS);
  }
  error "$opt_driver failed" if !close F;
  while ($grab=~/^Output written on (\S+.*?) [(]/mg) { $outname=$1 } # the last one
  error "no output pages from $opt_driver" if !defined $outname;
  # Output of
  # This is pdfTeX, Version 3.14159-1.00a-pretest-20011114-ojmw (Web2C 7.3.7):
  # </var/spool/texmf/pk/ljfour/public/cm/cmr10.600pk>
  # </usr/share/texmf/fonts/type1/bluesky/cm/cmr10.pfb>
  my($fn,$fon);
  $grab=~y@\n@@d; # pdfTeX inserts line breaks in the middle of <...>
  #die $grab;
  while ($grab=~/[<]([^<>]+[.]pf[ab])[>]/mgi) {
    $fon=$fn=$1;
    $fon=~s@^.*/@@; # basename
    #$had_alien_fonts=1 if substr($fn,0,8)ne'dff.fnt/'; # safety. But why?
    #print STDERR "$fon $fn\n";
    found_pf($fon,$fn);
  }
  #die;
  while ($grab=~m@[<]((?:/|[a-zA-Z]:\\)[^<>\n]+[/\\]([^<>/\\\n]+)[.]\d+pk)[>]@g) {
    # ^^^ e.g /var/spool/texmf/pk/ljfour/public/concrete/ccr10.600pk
    found_pk($2,$1);
  }
} elsif ($opt_dr==DR_XDVI) {
  $opt_onepass=1;
  $noq_p=1;
} else { die }
##die values %pfs;
info "Querying OK, found ".(scalar keys %pks)." bitmap and ".(scalar keys %pfs). " vector fonts";
# ^^^ different scalings of the same font are counted only once

# --- Run type1fix.pl on all the PFB fonts, so dvipdfm can subset+embed them properly

my $all_fonts_fixed;
my $prg_prefix="";

if (!$noq_p) {
  my $had_fixing=0;
  mkdir $dff_fnt, 0755;
  error "cannot mkdir: $dff_fnt" if !-d $dff_fnt or !-w $dff_fnt;
  $ENV{PATH}.=':.';
  my $have_type1fix=scalar(grep { /\A--dff-type1fix=(.*)/s and opt_val_istrue($1) } @opts) &&
    scalar(grep { -x "$_/type1fix.pl" } split/:/, $ENV{PATH});
  $all_fonts_fixed=1;
  my $dff_find_fonts_p=grep { /\A--dff-find-fonts=(.*)/s and opt_val_istrue($1) } @opts;
  while (my($name,$namext)=each%pfs) {
    # Dat: $namext is $name with a proper extension
    my($fontrel,$fontabs,$mage);
    #print "$namext => $fontabs\n";
    if (!$dff_find_fonts_p) {
    } elsif (index($namext,"/")>=0) {
      # Dat: may happen: pdfTeX dumps absoulte .pfb names (in $namext)
      $fontabs=$fontrel=$namext;
      $fontrel=~s@\A.*/@@s;
      $namext=$fontrel;
      if ("$dff_fnt/$namext" ne $fontabs) {
      } else { # get real (non-dff.pl) font filename
	$fontabs=getfont_absname($fontrel=$namext);
      }
      $mage=(-M $fontabs);
    } else {
      $fontabs=getfont_absname($fontrel=$namext);
      error "missing font: $fontrel\n" if !defined $fontabs;
      $mage=(-M $fontabs);
    }
    ##print "$namext -> $fontabs\n\n\n";
    # info "$fontabs $mage  $dff_fnt/$namext".(-M "$dff_fnt/$namext");
    if (-f "$dff_fnt/$namext") {
      no integer; # de real-number `<' comparison
      if (!defined $mage or (-M "$dff_fnt/$namext")<$mage) {
        info "Font already OK: $namext";
        next
      }
    } else {
      error "font file not found: $fontrel ($fontabs)" if!defined $mage;
    }
    ## print "PFB $fontrel : $fontabs.\n";
    if ($have_type1fix) {
      $had_fixing=1;
      info "Fixing font $fontabs";
      # unlink "$dff_fnt/$fontrel"; # undo -M() timestamp
      if (0!=system qw{perl -x -S type1fix.pl --set-leniv=0 --dump-spaces=no
        --dump-bars --dump-stde --dump-ends=no --pack --debug-warnings
        --chk-insize=no}, $fontabs, "pfb:", "$dff_fnt/$fontrel") {
        unlink "$dff_fnt/$fontrel";
        error "type1fix failed";
      }
      # ^^^ Imp: verify that $dff_fnt/$fontrel and $fontabs are different files
    } elsif ($all_fonts_fixed) {
      $all_fonts_fixed=0;
      # Dat: there is no need to copy fonts -- they can be used in place
      # Imp: partially use fixed fonts
    }
  }
  $opt_onepass=0 if $had_fixing; # fonts changed, run DR_* again
  if ($all_fonts_fixed and !$opt_onepass) {
    if ($opt_dr==DR_DVIPS) {
      delete $ENV{T1FONTS};
      # dvips(1) doesn't respect $ENV{T1FONTS} (dvipdfm and pdftex do), but
      # only $ENV{TEXPSHEADERS}, which is `.;$TEXMF/{dvips,pdftex,tex,fonts/type1}//'
      # by default. So we just change `,/fonts/type1}' -> `}' and we're done
      my $tph;
      my $tco;
      # Dat: we might already have $ENV{TEXPSHEADERS} from our caller. Never mind.
      # vvv BUGFIX at Tue Oct 12 13:17:01 CEST 2004
      #     On sziami.math.bme.hu this didn't return the appropriate Japanese
      #     dvipsj directories w/o --progname=dvipsj
      $tph=qx(kpsewhich --progname=dvips --expand-var=\\\$TEXPSHEADERS 2>/dev/null); chomp $tph;
      $tco=qx(kpsewhich --progname=dvips --expand-var=\\\$TEXCONFIG    2>/dev/null); chomp $tco;
      error 'cannot query $TEXPSHEADERS or $TEXCONFIG' if 2>length($tph) and 2>length($tco);
      chomp $tph;
      warning 'cannot remove `fonts/type1\' from $TEXPSHEADERS' if
        $tph!~s@,fonts/type1(?=[},])@@g and
        $tph!~s@(,fonts/\{enc),type1(?=[},])@$1@g;
        # ^^^ Dat: _must_ be present even for tetex-2.0 (??)
      $tph=~s@[!]+/@/@g; # strange, doesn't work: !/usr/share/texmf
      $ENV{TEXPSHEADERS}=$tph="$dff_fnt:".prepend_curdir($tph);
      $tco=~s@[!]+/@/@g;
      $ENV{TEXCONFIG}=$tco=prepend_curdir($tco);
    } else {
      $ENV{T1FONTS}=$dff_fnt;
      # ^^^ Dat: current dir (.) won't be examined. This is exactly what we want.
    }
    info "In env export T1FONTS=$dff_fnt";
    $prg_prefix="T1FONTS=$dff_fnt  ";
  }
}
# SUXX: perl v5.8.0 goto target here

# --- Run the driver finally

warning "Could not fix all fonts, keeping them so." if !$all_fonts_fixed and $opt_onepass;
info "Local config files: ".join(', ',@ty_local_conf) if @ty_local_conf;
if ($opt_dr==DR_DVIPDFM) {
  warning "type1fix.pl not found => font subsetting off, PDF'll be huge" if !$all_fonts_fixed;
  if ($opt_onepass and $all_fonts_fixed) {
    info "Not running dvipdfm again."
  } else {
    my @ARGT=("dvipdfm",($all_fonts_fixed?():("-e")),@ARGV);
    my $ARGS=join('  ', map { shq $_ } @ARGT);
    info "Running ${prg_prefix}$ARGS";
    error "dvipdfm failed" if 0!=system @ARGT;
  }
} elsif ($opt_dr==DR_DVIPS) {
  if ($opt_onepass) {
    info "Not running dvips again."
  } else {
    my $ARGS=join('  ', map { shq $_ } @dvips_full_argt);
    info "Running $ARGS";
    # Imp $prg_prefix with $TEXPSHEADERS
    ##die $ENV{TEXPSHEADERS};
    error "dvips failed" if 0!=system @dvips_full_argt;
  }
  my $do_keep_setpagedevice=0;
  my $force_bbox;
  if (grep { /\A--dff-safer=(.*)/s and opt_val_istrue($1) } @opts) {
    for my $filter (@special_filters) {
      info "Not running filter: $filter"
    }
  } else { # a DFF feature added at Sun Feb 22 19:42:31 CET 2004
    for my $filter (@special_filters) {
      # Example in TeX: \def\gobble#1{} \special{\string!\expandafter\gobble
      #   \string\%filter: pstops -pa4 '2:0L(21cm,0)+1L(21cm,14.85cm)}
      if ($filter eq ': keep_setpagedevice') {
        $do_keep_setpagedevice=1
      } elsif ($filter=~/\A: force_bbox\s+(.*?)\s*\Z(?!\n)/) {
        $force_bbox=$1
      } elsif ($filter=~/\A: force_papersize\s/) {
      } else {
	my $renname=$outname;
	$renname.="-pi" if $renname!~s@[.]([a-zA-Z]+)\Z(?!\n)@-pi.$1@;
	push @ty_temp, $renname if !@ty_temp or $ty_temp[-1] ne $renname;
	info "Renaming $outname to $renname";
	error "rename failed: $!\n" if !rename $outname, $renname;
	my $f2="$filter <".shq($renname)." >".shq($outname);
	info "Running filter: $f2";
	error "filter failed: $! 0x".sprintf("%x",$?) if
	  0!=system $f2 or !(-f$outname) or !(-s$outname);
	unlink $renname;
      }
    }
  }
  if ($do_keep_setpagedevice) {
    # Imp: fix multiple PStoPS dictionaries
    error "cannot reopen PS: $!\n" unless open F, "+< $outname";
    my $S="";
    # vvv Find first line w/o %% comments 
    while ($S!~/^[^%\n][^%\n]/m) {
      my $got=read F, $S, 4096, length $S;
      error "read error: $!" if !defined $got;
      die "no code in PS file" if !$got;
    }
    die if !defined read F, $S, 4096, length $S;
    $S=~s@%%EndProcSet.*@@s;
    my $T;
    if ($S=~m@\A([%][!].*\n([%].*\n)*)@
    and (($T=$1)=~/%%BeginProcSet: PStoPS .*\Z/)
    and $S=~s@^/setpagedevice @/s___________e @m) {
      # Dat: PStoPS undefines /setpagedevice, which we want to override here
      #      with our own /setpagedevice calls
      info "Keeping /setpagedevice after PStoPS";
      die unless sysseek F, 0, 0;
      die unless print F $S;
    }
    die unless close F;
  }
  if (defined$force_bbox) {
    error "cannot reopen PS: $!\n" unless open F, "+< $outname";
    my $S="";
    # vvv Find first line w/o %% comments 
    while ($S!~/^[^%\n][^%\n]/m) {
      my $got=read F, $S, 4096, length $S;
      error "read error: $!" if !defined $got;
      die "no code in PS file" if !$got;
    }
    $S=~s@/^[^%\n][^%\n].*@@s;
    if ($S=~m@^%%BoundingBox: (.*)@m) {
      if (length$1>length$force_bbox) {
        warning "Desired bbox spec too long: $force_bbox";
      } else {
        my $T="%%BoundingBox: ".(" "x(length($1)-length($force_bbox))).$force_bbox;
	die unless $S=~s@^%%BoundingBox: .*@$T@m;
	info "Forcing bbox to $force_bbox";
	die unless sysseek F, 0, 0;
	die unless print F $S;
      }
    }
    die unless close F;
  }
} elsif ($opt_dr==DR_PDFTEX) {
  if ($opt_onepass) {
    info "Not running $opt_driver again."
  } else {
    my @ARGT=($opt_driver, @ARGV);
    my $ARGS=join('  ', map { shq $_ } @ARGT);
    info "Running ${prg_prefix}$ARGS";
    error "$opt_driver failed" if 0!=system @ARGT;
  }
} elsif ($opt_dr==DR_XDVI) {
  if (!grep { $_ eq '-not1lib' } @ARGV) {
    $ENV{ps_to_pk}='ps2pk'; # Dat: doesn't work well for dvips(1)
    $prg_prefix.="ps_to_pk=ps2pk ";
    # ^^^ Dat: mktexpk(1) uses export ps_to_pk=ps2pk not to call gsftopk(1),
    #     which uses psfonts.map. ps2pk uses ps2pk.map instead, which is the same
    #     file that xdvi(1) uses with t1lib rendering.
    # Dat: xdvi(1) uses internal t1lib whenever possible (even with ExtendFont
    #      and ReEncodeFont), but may call mktexpk(1)
  }
  my @ARGT=($opt_driver, @ARGV);
  my $ARGS=join('  ', map { shq $_ } @ARGT);
  info "Running ${prg_prefix}$ARGS";
  error "$opt_driver failed" if 0!=system @ARGT;
  # Dat: continue running to get a chance of removing tmp files
} else { die }

# --- Bye

info "Junk files: $dff_fnt/*, ".join(', ', @config_fnc);
warning "Bitmap fonts in output: ".join(' ',sort keys %pks) if %pks;
if ($opt_dr eq DR_DVIPDFM) {
  info "Success converting DVI: $dviname";
  info "Created PDF size: ".(-s$outname)." bytes"; # Dat: -s($outname) is wrong
  info "Created PDF: $outname";
} elsif ($opt_dr eq DR_DVIPS) {
  info "Success converting DVI: $dviname";
  info "Created PS size: ".(-s$outname)." bytes";
  info "Created PS: $outname";
} elsif ($opt_dr eq DR_PDFTEX) {
  my $texname=$ARGV[-1];
  addext $texname, '.tex';
  info "Success converting TeX source: $texname";
  info "Created PDF size: ".(-s$outname)." bytes";
  info "Created PDF: $outname"; # Imp: verify if DVI?
} elsif ($opt_dr==DR_XDVI) {
} else { die }
undef $outname; # don't remove it

__END__
